import 'package:mpv/cancelable/cancelable.dart';
import 'package:mpv/view/view.dart';

abstract class Presenter<V extends View> {
  final Map<String, Cancelable> _stack = {};
  V view;

  Presenter(this.view);

  addToStack(String key, Cancelable cancelable) {
    _stack[key] = cancelable;
  }

  cancel(String key) {
    final cancelable = _stack[key];
    if (cancelable != null) {
      _stack.remove(key);
      cancelable.cancel();
    }
  }

  close() {
    view?.close();
    _stack.forEach((_, cancelable) => cancelable.cancel());
  }
}
