import 'package:flutter/widgets.dart';
import 'package:mpv/presenter/presenter.dart';


abstract class WithPresenter<P extends Presenter> {
  P mPresenter;

  P createPresenter();
}

mixin MixinPresenter<W extends StatefulWidget, P extends Presenter> on State<W>
    implements WithPresenter<P> {
  P mPresenter;

  P get presenter => mPresenter;

  @override
  void initState() {
    mPresenter = createPresenter();
    super.initState();
  }

  @override
  void dispose() {
    presenter.close();
    super.dispose();
  }
}

abstract class StateWithPresenter<W extends StatefulWidget, P extends Presenter>
    extends State<W> with MixinPresenter<W, P> {}
